Package org.apache.sis.util.collection

# Class WeakValueHashMap<K,V>

Object
AbstractMap<K,V>
WeakValueHashMap<K,V>

Type Parameters:
  `K` - the class of key elements.
  `V` - the class of value elements.

All Implemented Interfaces:
  `Map<K,V>`

public class WeakValueHashMap<K,V> extends AbstractMap<K,V>
A hashtable-based map implementation that uses weak references, leaving memory when an entry is not used anymore. An entry in a `WeakValueHashMap` will automatically be removed when its value is no longer in ordinary use. This class is similar to the standard `WeakHashMap` class, except that weak references apply to values rather than keys.

Note that this class is not a cache, because the entries are discarded as soon as the garbage collector determines that they are no longer in use. If caching service are wanted, or if concurrency are wanted, consider using `Cache` instead.

This class is convenient for avoiding the creation of duplicated elements, as in the example below:

>     K key = ...
>     V value;
>     synchronized (map) {
>         value = map.get(key);
>         if (value == null) {
>             value = ...; // Create the value here.
>             map.put(key, value);
>         }
>     }

In the above example, the calculation of a new value needs to be fast because it is performed inside a synchronized statement blocking all other access to the map. This is okay if that particular `WeakValueHashMap` instance is not expected to be used in a highly concurrent environment.

`WeakValueHashMap` works with array keys as one would expect. For example arrays of `int[]` are compared using the `Arrays​.equals(int[], int[])` method.

## Thread safety

The same `WeakValueHashMap` instance can be safely used by many threads without synchronization on the part of the caller. But if a sequence of two or more method calls need to appear atomic from other threads perspective, then the caller can synchronize on `this`.

Since:
  0.3
See Also:
  - `WeakHashMap`
  - `WeakHashSet`
  - `Cache`

Defined in the `sis-utility` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class AbstractMap

  `AbstractMap​.SimpleEntry<K extends Object,V extends Object>, AbstractMap​.SimpleImmutableEntry<K extends Object,V extends Object>`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `WeakValueHashMap(Class<K> keyType)`
  Creates a new `WeakValueHashMap`.
  `WeakValueHashMap(Class<K> keyType, boolean identity)`
  Creates a new `WeakValueHashMap`, optionally using reference-equality in place of object-equality.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `clear()`
  Removes all of the elements from this map.
  `boolean`
  `containsKey(Object key)`
  Returns `true` if this map contains a mapping for the specified key.
  `boolean`
  `containsValue(Object value)`
  Returns `true` if this map maps one or more keys to this value.
  `Set<Map​.Entry<K,V>>`
  `entrySet()`
  Returns a set view of the mappings contained in this map.
  `V`
  `get(Object key)`
  Returns the value to which this map maps the specified key.
  `V`
  `put(K key, V value)`
  Associates the specified value with the specified key in this map.
  `V`
  `putIfAbsent(K key, V value)`
  Associates the specified value with the specified key in this map if no value were previously associated.
  `V`
  `remove(Object key)`
  Removes the mapping for this key from this map if present.
  `int`
  `size()`
  Returns the number of key-value mappings in this map.

  ### Methods inherited from class AbstractMap

  `clone, equals, hashCode, isEmpty, keySet, putAll, toString, values`

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Map

  `compute, computeIfAbsent, computeIfPresent, forEach, getOrDefault, merge, remove, replace, replace, replaceAll`

- ## Constructor Details

  - ### WeakValueHashMap

    public WeakValueHashMap(Class<K> keyType)
    Creates a new `WeakValueHashMap`.
    Parameters:
      `keyType` - the type of keys in the map.

  - ### WeakValueHashMap

    public WeakValueHashMap(Class<K> keyType, boolean identity)
    Creates a new `WeakValueHashMap`, optionally using reference-equality in place of object-equality. If `identity` is `true`, then two keys `k1` and `k2` are considered equal if and only if `(k1 == k2)` instead of if `k1​.equals(k2)`.

    Reference-equality semantic is rarely used. See the `IdentityHashMap` class javadoc for a discussion about drawbacks and use cases when reference-equality semantic is useful.

    Parameters:
      `keyType` - the type of keys in the map.
      `identity` - `true` if the map shall use reference-equality in place of object-equality when comparing keys, or `false` for the standard behavior.
    Since:
      0.4

- ## Method Details

  - ### size

    public int size()
    Returns the number of key-value mappings in this map.
    Specified by:
      `size` in interface `Map<K,V>`
    Overrides:
      `size` in class `AbstractMap<K,V>`
    Returns:
      the number of entries in this map.

  - ### containsKey

    public boolean containsKey(Object key)
    Returns `true` if this map contains a mapping for the specified key. Null keys are considered never present.
    Specified by:
      `containsKey` in interface `Map<K,V>`
    Overrides:
      `containsKey` in class `AbstractMap<K,V>`
    Parameters:
      `key` - key whose presence in this map is to be tested.
    Returns:
      `true` if this map contains a mapping for the specified key.

  - ### containsValue

    public boolean containsValue(Object value)
    Returns `true` if this map maps one or more keys to this value. Null values are considered never present.
    Specified by:
      `containsValue` in interface `Map<K,V>`
    Overrides:
      `containsValue` in class `AbstractMap<K,V>`
    Parameters:
      `value` - value whose presence in this map is to be tested.
    Returns:
      `true` if this map maps one or more keys to this value.

  - ### get

    public V get(Object key)
    Returns the value to which this map maps the specified key. Returns `null` if the map contains no mapping for this key. Null keys are considered never present.
    Specified by:
      `get` in interface `Map<K,V>`
    Overrides:
      `get` in class `AbstractMap<K,V>`
    Parameters:
      `key` - key whose associated value is to be returned.
    Returns:
      the value to which this map maps the specified key.

  - ### put

    public V put(K key, V value) throws NullArgumentException
    Associates the specified value with the specified key in this map. The value is associated using a `WeakReference`.
    Specified by:
      `put` in interface `Map<K,V>`
    Overrides:
      `put` in class `AbstractMap<K,V>`
    Parameters:
      `key` - key with which the specified value is to be associated.
      `value` - value to be associated with the specified key.
    Returns:
      the previous value associated with specified key, or `null` if there was no mapping for key.
    Throws:
      `NullArgumentException` - if the key or the value is `null`.

  - ### putIfAbsent

    public V putIfAbsent(K key, V value) throws NullArgumentException
    Associates the specified value with the specified key in this map if no value were previously associated. If an other value is already associated to the given key, then the map is left unchanged and the current value is returned. Otherwise the specified value is associated to the key using a `WeakReference` and `null` is returned.
    Parameters:
      `key` - key with which the specified value is to be associated.
      `value` - value to be associated with the specified key.
    Returns:
      the current value associated with specified key, or `null` if there was no mapping for key.
    Throws:
      `NullArgumentException` - if the key or the value is `null`.
    Since:
      0.7

  - ### remove

    public V remove(Object key)
    Removes the mapping for this key from this map if present.
    Specified by:
      `remove` in interface `Map<K,V>`
    Overrides:
      `remove` in class `AbstractMap<K,V>`
    Parameters:
      `key` - key whose mapping is to be removed from the map.
    Returns:
      previous value associated with specified key, or `null` if there was no entry for key.

  - ### clear

    public void clear()
    Removes all of the elements from this map.
    Specified by:
      `clear` in interface `Map<K,V>`
    Overrides:
      `clear` in class `AbstractMap<K,V>`

  - ### entrySet

    public Set<Map.Entry<K,V>> entrySet()
    Returns a set view of the mappings contained in this map. Each element in this set is a `Map​.Entry`.
    Specified by:
      `entrySet` in interface `Map<K,V>`
    Specified by:
      `entrySet` in class `AbstractMap<K,V>`
    Returns:
      a set view of the mappings contained in this map.